<?php
namespace Magenest\Salesforce\Observer\Customer;

use Magenest\Salesforce\Observer\SyncObserver;
use Magento\Framework\Event\Observer;
use Magento\Newsletter\Model\Subscriber;

class SyncSubscriber extends SyncObserver
{
    /** @var bool */
    protected $_isProcessed = false;

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        if (!$this->_isProcessed) {
            try {
                if ($this->helper->getEnabledSyncConfig('subscriber')) {
                    /** @var Subscriber $subscriber */
                    $subscriber = $observer->getEvent()->getSubscriber();
                    if ($subscriber->isStatusChanged()) {
                        $this->subscriber->syncOne($subscriber);
                    }
                }
                $this->_isProcessed = true;
            } catch (\Throwable $e) {
                $this->logger->info($e->getMessage());
            }
        }
    }
}
